﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Diagnostics;

namespace WindowsFormsApplication51
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string filename = Path.Combine(Path.GetDirectoryName(Application.ExecutablePath), "x.xlsx");
            this.ultraGridExcelExporter1.Export(this.ultraGrid1, filename);
            Process.Start(filename);
        }

        private void ultraGrid1_InitializeLayout(object sender, Infragistics.Win.UltraWinGrid.InitializeLayoutEventArgs e)
        {
            e.Layout.Bands[0].Columns["RATE"].Formula = "if( [TOTAL] <>0 , [NG] /  [TOTAL] ,    dbnull()    )";
            e.Layout.Bands[0].Columns["RATE"].Format = "0.000%";
        }

        private void ultraGridExcelExporter1_FormulaExportError(object sender, Infragistics.Win.UltraWinGrid.ExcelExport.FormulaExportErrorEventArgs e)
        {
            //MessageBox.Show(e.Error + "," + e.ErrorText + "," + e.ExcelFormula + "," + e.GridFormula);

            //if (e.GridFormula == "if( [Column 0] <>0 , [Column 1] /  [Column 0] ,  dbnull() )") 
            if (string.IsNullOrWhiteSpace(e.GridFormula)==false && e.GridFormula.Contains("dbnull()"))
            { 
                e.ExcelFormula = e.ExcelFormula.Substring(0, e.ExcelFormula.Length - 1) + "\"\" )"; 
                e.ApplyInvalidFormulaIfPossible = true; 
            }

        }
    }
}
